<script lang="ts">
import Vue from 'vue';
import SideMenuChild from './side-menu-child.vue';
import { scrollActions } from '~/lib/scrollActions';

export default Vue.extend({
  name: 'SideMenu',
  components: {
    SideMenuChild,
  },
  props: {
    links: {
      type: Array,
      required: true,
      default: null,
    },
    withScroll: {
      type: Boolean,
      required: false,
      default: false,
    },
    sensitivity: {
      type: Number,
      required: false,
      default: 0.5,
    },
  },
  data() {
    return {
      currentLinkIndex: 0,
    };
  },
  computed: {
    isMultiLevel(): boolean {
      return this.links.some((link: any) => link.children);
    },
  },
  mounted() {
    window.addEventListener('load', () => {
      const config = {
        observerOptions: {
          root: null,
          rootMargin: '0px',
          threshold: this.sensitivity,
        },
        targetIdentifiers: this.links.map((link: any) =>
          link.href.replace('#', ''),
        ),
        warningLabel: 'SideMenu',
      };
      const callback = (entries: any[]) => {
        entries.forEach((entry) => {
          if (entry.isIntersecting) {
            this.currentLinkIndex = this.links.findIndex(
              (item: any) => item.href === `#${entry.target.id}`,
            );
          }
        });
      };
      scrollActions(config, callback);
    });
  },
});
</script>

<template>
  <div class="side-menu">
    <label v-if="isMultiLevel" class="side-menu__label"> On this page: </label>
    <ul class="side-menu__list" :class="{ 'multi-level': isMultiLevel }">
      <li v-for="(link, index) in links" :key="index" class="side-menu__item">
        <div class="side-menu__item__container">
          <router-link
            class="side-menu__link"
            :class="{
              'side-menu__link--active':
                withScroll && currentLinkIndex === index,
            }"
            :active-class="!withScroll ? 'side-menu__link--active' : ''"
            :to="{ path: '', hash: link.href }"
            :data-ga-name="link.data_ga_name"
            :data-ga-location="link.data_ga_location"
            >{{ link.text }}
          </router-link>
          <div class="side-menu__line"></div>
        </div>
        <side-menu-child v-if="link.children" :links="link.children" />
      </li>
    </ul>
  </div>
</template>

<style scoped lang="scss">
.side-menu {
  display: none;
  top: 6rem;
  right: 0;
  max-width: 32rem;
  padding-top: 5rem;
  max-height: 90vh;
  overflow-y: scroll;

  &__label {
    display: block;
    font-size: 10px;
    line-height: 20px;
    margin-bottom: 12px;
    margin-top: -5px;
    text-transform: uppercase;
  }

  &__line {
    height: 1px;
    background: #f2f2f2;
    width: 100%;
    margin-top: 4px;
  }

  @media (min-width: $breakpoint-2xl) {
    transform: none;
    width: max-content;
    position: fixed;
    padding-bottom: 0;
    display: block;
  }

  &__list {
    margin-bottom: 18px;
    text-align: left;
    padding: 0;
    list-style-type: none;
    &:not(.multi-level) {
      .side-menu__link--active + .side-menu__line,
      .side-menu__item__container:hover .side-menu__line {
        background-color: $color-secondary-200;
        height: 2px;
        transition: all ease-in 0.2s;
      }
    }

    &.multi-level {
      .side-menu__link:hover {
        color: $color-secondary-200;
      }
      .side-menu__item__container:hover .side-menu__line {
        background-color: $color-secondary-200;
        height: 2px;
        transition: all ease-in 0.2s;
      }
    }
  }

  &__item {
    width: 20rem;
    &__container {
      display: flex;
      align-items: center;
      margin-bottom: 18px;
    }
  }

  &__link {
    position: relative;
    text-decoration: none;
    font-size: 18px;
    line-height: 20px;
    padding-right: 10px;
    white-space: nowrap;
    cursor: pointer;
    transition: all ease-in 0.2s;

    &:hover {
      text-decoration: none;
    }

    &--active {
      font-weight: 600;
    }
  }

  .multi-level {
    li a {
      color: #333;
      font-size: 14px;
      line-height: 20px;
      font-weight: 600;
    }
  }
}
</style>
